#Klasa TeGraf - klasaTeGraf.py
from matrica import *
class TeGraf(Matrica):
    def __init__(self, n, grane = None):
        super().__init__(n, n)
        for i in range(n):                          
            for j in range(n):
                self[i, j] = float('inf')
        if grane != None:
            for i, j in grane.keys():
                self[i, j] = grane[i, j]
                self[j, i] = grane[i, j]
        return
    
    def __repr__(self):                            
        s = ''
        for i in range(self.n):
            for j in range(self.m):
                s = s + '{0:4}'.format(self[i, j])      
            s = s + '\n'
        return s

    def najblizi_susjed(self, r):                   
        t = 0
        for i in range(1, self.n):
            if self[r, i] < self[r, t]:
                t = i
        if t != float('inf'):
            return t
        else:
            return -1

    def kopiraj(self):                   		 
        t = TeGraf(self.n)
        for i in range(self.n):
            for j in range(self.n):
                t[i, j] = self[i, j]
        return t
