from klasaZ import *
from matrica import *

def cezar(s):
    s2 = ''
    for c in s:
        n = ord(c) - 65
        n += 3
        n %= 26
        s2 += chr(n + 65)
    return s2

def pomak(s, k):
    s2 = ''
    for c in s:
        n = ord(c) - 65
        n += k
        n %= 26
        s2 += chr(n + 65)
    return s2

def afino(s, a, b):
    s2 = ''
    for c in s:
        n = ord(c) - 65
        n = (n * a + b) % 26
        s2 += chr(n + 65)
    return s2

def vigenere(s, k):
    ## Ponavljamo ključ tako da ima najmanje len(s) znakova
    k *= len(s) // len(k) + 1
    s2 = ''
    for i in range(len(s)):
        x = ord(s[i]) - 65
        y = ord(k[i]) - 65
        z = (x + y) % 26 + 65
        s2 += chr(z)
    return s2

def stupcasta(t, p):
    r = len(t) // len(p)    
    if len(t) % len(p) > 0:
        r += 1
    s = len(p)
    a = Matrica(r, s)
    for i in range(r):
        for j in range(s):
            if i * s + j < len(t):
                a[i, j] = t[i * s + j]
            else:
                a[i, j] = 'X'
    b = Matrica(r, s)
    for i in range(r):
        for j in range(s):
            b[i, p[j] - 1] = a[i, j]
    s2 = ''
    for i in range(s):
        for j in range(r):
            s2 += b[j, i]
    return s2


def mod_pot (a, b, n):
    bz = bin(b)[2:]
    p = a
    v = 1
    for i in range(1, len(bz) + 1):
        if (bz[-i] == '1'):
            v = v * p % n
        p = p * p % n
    return v
