from datetime import *
class Datum(date):
    def __init__(self, y, m, d):
        super().__init__()
        return

    def __sub__(self, d):
        '''Razlika - broj dana između dvaju datuma'''
        a = self.toordinal()
        b = d.toordinal()
        return a - b

    def __add__(self, n): 
        '''Zbrajanje - datum koji će biti n dana nakon danog datuma'''       
        return Datum.fromordinal(self.toordinal() + n)

    def __repr__(self):
        d, m, y = str(self.day), str(self.month), str(self.year)
        if len(d) == 1:
            d = '0' + d
        if len(m) == 1:
            m = '0' + m
        while len(y) < 4:
            y = '0' + y
        return '{0}.{1}.{2}'.format(d, m, y)
