from klasaTeGraf import *
from heapq import *

def dijkstra(graf, poč_čvor):
    posjećeni = set()                                   
    udaljenosti = dict()                                
    for i in range(graf.n):                             
        udaljenosti[i] = float('inf') 
    udaljenosti[poč_čvor] = 0                           
    red = []                                            
    heappush(red, (udaljenosti[poč_čvor], poč_čvor))    
    prethodnici = [0] * graf.n                          
    while len(red) > 0:                                 
        čvor = heappop(red)[1]                          
        if čvor not in posjećeni:                       
            posjećeni |= {čvor}                         
            for k in range(graf.n):                     
                d = udaljenosti[čvor] + graf[čvor, k]   
                if d < udaljenosti[k]:                  
                    udaljenosti[k] = d                  
                    prethodnici[k] = čvor               
                    heappush(red, (udaljenosti[k], k))  
    grane = dict()
    for i in range(graf.n):                             
        grane[prethodnici[i], i] = graf[prethodnici[i], i]
    return udaljenosti, TeGraf(graf.n, grane)           
